Source Output


 
Thread Tools Search this Thread
Top Forums UNIX for Advanced & Expert Users Source Output
# 1  
Old 10-10-2012
Source Output

Hi all.
I am trying to include the output of a command in a shell script (sh shell) but with no success.
Scenario is this: I have some XML and binary configuration files and I have an executable who writes a file with some shell variables I usually include in my shell script (executable "translates" configurations in shell variables).
At the beginning of scripts I put:

Code:
myexe > /tmp/config
. /tmp/config

(
/tmp/config containing something like:
Code:
IP="192.168.10.2"
SWITCH1="ON"
SWITCH2="OFF"

)

It will be good to use something like:

Code:
. $(myexe)

including directly the output of myexe executable instead of including an external file.

Do you know a way to accomplish this.
Thank you very much in advance.
TT:

Moderator's Comments:
Mod Comment edit by bakunin: please view this code tag video for how to use code tags when posting code and data.

Last edited by bakunin; 10-10-2012 at 10:52 AM..
# 2  
Old 10-10-2012
Quote:
Originally Posted by ticiotix
Code:
myexe > /tmp/config
. /tmp/config

Seems like this is the only way if you want to extract an environment which should be added to the environment of the currently running script. A command like

Code:
$(myexe)

will execute "myexe" in a subshell. (This is what "$(...)" means: execute what is inside the braces in a subshell.) If you change the environment in this subshell the changes will be lost once you exit it.

The only thing i suggest is to "chmod" the file "/tmp/config" before you run it. It has no execute rights from the start and even if this works it is counter-intuitive.

I hope this helps.

bakunin
# 3  
Old 10-10-2012
Thanks Bakunin!!!
I realize now I hid the real problem...
My question originated because when I execute:

Code:
myexe > /tmp/config
. /tmp/config

in concurrent scripts, sometimes, the second line is executed when someone other is writing /tmp/config, ending in an error.
Perhaps the simpler idea is to change script in :

Code:
myfile=$(mktemp)
myexe > $myfile
.  $myfile
rm  $myfile

or something using "flock"...
Thank you very much.
TT:

Moderator's Comments:
Mod Comment edit by bakunin: i would really appreciate you using CODE-tags instead of Italics. Thank you for your consideration.

Last edited by bakunin; 10-10-2012 at 11:50 AM..
# 4  
Old 10-10-2012
First off, if you write to temporary files you should always prepare a place for these first and clean this place upon exit. Usually you can use the PID variable to make the places name unique, because the PID is always unique. I do it usually the following way (sketch only):

Code:
#! /bin/ksh

trap 'rm -rf "$TMPDIR" 1>/dev/null 2>/dev/null' 0

PROGNAME="$(basename $0)"
TMPDIR="/tmp/${PROGNAME}_$$"

fTmp1="${TMPDIR}/somefile"
fTmp2="${TMPDIR}/otherfile"

mkdir "$TMPDIR" || {
     print -u2 "ERROR: cannot create $TMPDIR, exiting."
     exit 2
}

... code ...

cmd > "$fTmp1"

while read line ; do
     ....
done < "$fTmp2"

.... code ....

exit 0

This way each instance of a script gets its own temp dir, puts everything it uses in there and upon exit (regardless which exit, even when terminated from outisde) it cleans up. The only way to have the temp files not cleaned is to terminate it with a "kill -9".

I hope this helps.

bakunin
# 5  
Old 10-11-2012
Quote:
Originally Posted by bakunin
First off, if you write to temporary files you should always prepare a place for these first and clean this place upon exit. Usually you can use the PID variable to make the places name unique, because the PID is always unique. I do it usually the following way (sketch only):

Code:
#! /bin/ksh

trap 'rm -rf "$TMPDIR" 1>/dev/null 2>/dev/null' 0

 ... ... ...

exit 0

This way each instance of a script gets its own temp dir, puts everything it uses in there and upon exit (regardless which exit, even when terminated from outisde) it cleans up. The only way to have the temp files not cleaned is to terminate it with a "kill -9".

I hope this helps.

bakunin
This is a great example of defensive programming, but the commands in trap 'commands' 0 will only be executed on a normal exit of the program. If the program is terminated by any signal (such as SIGINT or SIGQUIT which can easily be generated from the keyboard while a script is running interactively), the commands in this trap will not be executed.

If you wanted to perform the cleanup on exit and on termination by the signals SIGHUP, SIGINT, SIGQUIT, and SIGTERM you could use:
Code:
trap 'rm -rf "$TMPDIR" 1>/dev/null 2>/dev/null' EXIT HUP INT QUIT TERM

on systems that support the latest POSIX standard requirements. On UNIX branded systems, this would be equivalent to:
Code:
trap 'rm -rf "$TMPDIR" 1>/dev/null 2>/dev/null' 0 1 2 3 15

If you aren't using a UNIX branded implementation, the signal numbers listed above might not work on your system. The signal numbers used on your system should appear a file like /usr/include/signal.h or in some file it #includes. (There may be variant directories on your system corresponding to different versions of the standards and other ABI or API specifications your system supports.)
# 6  
Old 10-11-2012
Quote:
Originally Posted by Don Cragun
If you wanted to perform the cleanup on exit and on termination by the signals SIGHUP, SIGINT, SIGQUIT, and SIGTERM you could use:
Code:
trap 'rm -rf "$TMPDIR" 1>/dev/null 2>/dev/null' 0 1 2 3 15

If you aren't using a UNIX branded implementation, the signal numbers listed above might not work on your system.
Understood, but as i sense that i am in for yet another piece of knowledge i missed until now, excuse the request for clarification:

I more or less (my real scripts are a bit more elaborated than the sketch shown here) followed the recommendations laid down here as my understanding was that "trap 0" in ksh is not a real signal but always executed at scripts end, regardless of how this ending came to pass - by signal, by simply end of program flow or by user interaction (pressing CTRL-C or something such).

Could you please clarify?

bakunin
This User Gave Thanks to bakunin For This Post:
# 7  
Old 10-11-2012
The standards require that a trap action 0 (or trap action EXIT execute the specified action on exit, but never defines the term "exit" in this context. I had always interpreted "on exit" to mean when a shell script calls the exit special built-in utility or "falls off the end of the script"(which exits with the exit code provided by the last simple command executed by the script). But, at least bash and ksh behave as you expect.

Obviously, the commands specified by the action in a trap action EXIT command won't be executed if the shell is terminated by a SIGKILL signal since the shell can't catch a SIGKILL to invoke the actions specified by appropriate traps. If the standard is interpreted as you expect, then no system conforms to the standard because the standard doesn't allow an exception for being terminated by SIGKILL.

Thanks for pointing this out to me. I'll file a bug report against the POSIX standards and the Single UNIX Specification to try to get the next version of the standards to match existing practice in this area.

- Don
Login or Register to Ask a Question

Previous Thread | Next Thread

9 More Discussions You Might Find Interesting

1. Shell Programming and Scripting

Add source file name to file output

OS: Linux kernel ver: 2.6x shell: Korn(ksh) hi. We are required to read contents for mutliple GZIP(.gz) files and perform some custom sanity checks downstream, example of such a check can a validation for the length of each record. We should accepts records which are 320 chars long and... (1 Reply)
Discussion started by: kumarjt
1 Replies

2. Red Hat

Command understanding the output file destination in case of standard output!!!!!

I ran the following command. cat abc.c > abc.c I got message the following message from command cat: cat: abc.c : input file is same as the output file How the command came to know of the destination file name as the command is sending output to standard file. (3 Replies)
Discussion started by: ravisingh
3 Replies

3. Shell Programming and Scripting

Displaying log file pattern output in tabular form output

Hi All, I have result log file which looks like this (below): from the content need to consolidate the result and put it in tabular form 1). Intercomponents Checking Passed: All Server are passed. ====================================================================== 2). OS version Checking... (9 Replies)
Discussion started by: Optimus81
9 Replies

4. Shell Programming and Scripting

script to mail monitoring output if required or redirect output to log file

Below script perfectly works, giving below mail output. BUT, I want to make the script mail only if there are any D-Defined/T-Transition/B-Broken State WPARs and also to copy the output generated during monitoring to a temporary log file, which gets cleaned up every week. Need suggestions. ... (4 Replies)
Discussion started by: aix_admin_007
4 Replies

5. Shell Programming and Scripting

Redirect output to a different text file depending source of data

I have a list of DNS servers I need to look up information on. Each of these servers has a master and a slave database. Essentially what I need to do is create two text files for each server. One with the Master view and one with the Slave view. There's 20 servers, in the end I should have 40 text... (4 Replies)
Discussion started by: spartan22
4 Replies

6. Shell Programming and Scripting

Awk script to run a sql and print the output to an output file

Hi All, I have around 900 Select Sql's which I would like to run in an awk script and print the output of those sql's in an txt file. Can you anyone pls let me know how do I do it and execute the awk script? Thanks. (4 Replies)
Discussion started by: adept
4 Replies

7. UNIX for Dummies Questions & Answers

Read rows from source file and concatenate output

Hi guys; TBH I am an absolute novice, when it comes to scripting; I do have an idea of the basic commands... Here is my problem; I have a flatfile 'A' containing a single column with multiple rows. I have to create a script which will use 'A' as input and then output a string in in the... (0 Replies)
Discussion started by: carlos_anubis
0 Replies

8. Shell Programming and Scripting

write page source to standard output

I'm new to PERL, but I want to take the page source and write it to a file or standard output. I used perl.org as a test website. Here is the script: use strict; use warnings; use LWP::Simple; getprint('http://www.perl.org') or die 'Unable to get page'; exit 0; ... (1 Reply)
Discussion started by: wxornot
1 Replies

9. Shell Programming and Scripting

how to make a line BLINKING in output and also how to increase font size in output

how to make a line BLINKING in output and also how to increase font size in output suppose in run a.sh script inside echo "hello world " i want that this should blink in the output and also the font size of hello world should be big .. could you please help me out in this (3 Replies)
Discussion started by: mail2sant
3 Replies
Login or Register to Ask a Question